<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <title>List User</title>
</head>

<body>
    <div class="container">
        <h2 class="text-center mt-4">Danh sách người dùng đăng ký</h2>
        <button class="btn btn-success mb-1 insert-user">Thêm User</button>
        <table id="table-users" class="table table-striped table-bordered table-hover ">
            <thead>
                <tr>
                    <th scope="col">ID</th>
                    <th scope="col">Firstname</th>
                    <th scope="col">Lastname</th>
                    <th scope="col">Country</th>
                    <th scope="col">Subject</th>
                    <th scope="col">Customer Type</th>
                    <th scope="col">Register Status</th>
                    <th scope="col">Action</th>
                </tr>
            </thead>
            <tbody>



            </tbody>

        </table>
    </div>
</body>
<script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $(document).ready(function () {
        onPageLoading()
        // gán sự kiện cho nút sửa
        $("#table-users").on("click", ".edit-user", function () {
            onBtnEditUserClick(this)
        });
        // gán sự kiện cho nút xóa
        $("#table-users").on("click", ".delete-user", function () {
            onBtnDeleteUserClick(this);
        });
         // gán sự kiên cho nút thêm user:
         $(".insert-user").on("click", function () {
            window.location.href = "insertUser.html"
        });

    });
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
        //load data to table
        requestDataAndLoadDataToTable();
    }
    // gán sự kiện cho nút edit:
    function onBtnEditUserClick(paramEdit) {
        var vUserId = $(paramEdit).data("id");
        console.log(vUserId);
        const vDETAIL_FORM_URL = "updateUser.html"
        var vUrlToOpenNewPage = vDETAIL_FORM_URL + "?id="+vUserId
        window.location.href = vUrlToOpenNewPage;
    }
    // gán sự kiện cho nút Delete
    function onBtnDeleteUserClick(paramDelete) {
        var vUserId = $(paramDelete).data("id");
        console.log(vUserId);
    }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    //hàm load data to table:
    function requestDataAndLoadDataToTable() {
        $.ajax({
            url: "http://203.171.20.210:8080/crud-api/users/",
            type: "GET",
            success: function (paramUsers) {
                loadUserToTable(paramUsers);
            },
            error: function (paramError) {
                console.log(paramError.status);
            }
        });
    }
    //ham load du lieu vao table:
    //input: mang users
    function loadUserToTable(paramUsers) {
        var vUserTable = $("#table-users");
        for (var bI = 0; bI < paramUsers.length; bI++) {
            //tạo ra dòngm gắn vào table
            var bNewRow = $("<tr>").appendTo(vUserTable);
            //tạo ra từng ô, gán dữ liệu cho ô và gắn vào dòng mới vừa tạo ở trên
            $("<td>", { html: paramUsers[bI].id }).appendTo(bNewRow);
            $("<td>", { html: paramUsers[bI].firstname }).appendTo(bNewRow);
            $("<td>", { html: paramUsers[bI].lastname }).appendTo(bNewRow);
            $("<td>", { html: paramUsers[bI].country }).appendTo(bNewRow);
            $("<td>", { html: paramUsers[bI].subject }).appendTo(bNewRow);
            $("<td>", { html: paramUsers[bI].customerType }).appendTo(bNewRow);
            $("<td>", { html: paramUsers[bI].registerStatus }).appendTo(bNewRow);
            //ô action:
            var bActionCell = $("<td>").appendTo(bNewRow);

            //nút sửa:
            $("<button>", {
                html: "Sửa",
                class: "btn btn-primary mr-1 edit-user"
            })
                .data("id", paramUsers[bI].id)
                .appendTo(bActionCell)
            //nut xóa:
            $("<button>", {
                html: "Xóa",
                class: "btn btn-danger delete-user"
            })
                .data("id", paramUsers[bI].id)
                .appendTo(bActionCell)

        }
    }




</script>

</html>